package Puma::ServerPages::Global;
use ibase Exporter;

=description

	Global functions for ServerPages

=cut

@EXPORT = qw( cleanhash iurl );

use strict;

# --- function used to remove keys from a hash that have a '' value ---
sub cleanhash {
	my %hash = @_;
	foreach my $key (keys %hash) {
		if ($key eq '') {
			delete $hash{$key};
		}
	}
	return %hash;
}

# --- iurl - rewrite URL to be rooted off ENV{INCLUDE_URI} ---
sub iurl {
	my $url = join '/', @_;

	# --- add ENV{INCLUDE_URI} if we're going off the root ---
	$url = "$ENV{INCLUDE_URI}/$url"
		if $url =~ /^\// && $ENV{INCLUDE_URI};

	# --- remove excess slashes ---
	$url =~ s|/+|/|g;

	return $url;
}

1;

__END__

sub fixpath {
	return undef unless @_;

	my $file = $_[0];
	if (@_ > 1) {
		if ($_[1] =~ /^\//) {
			$file = join '', @_;
		} else {
			$file = $_[1];
		}
	}
	$file =~ s|/+|/|g;

	return $file;
}
