package Puma::ServerPages::Session;
use ibase Puma::State::DDState;

=copyright

	Puma - Perl Universal Markup
	Copyright (c) 2001, Ingmar Ellenberger.  All rights reserved.
	Software is distributed AS IS.  No warranties, expressed or implied.

	This license is temporary, pending the selection of an appropriate
	open-source license.

=description

	Puma::ServerPages::Session - A simple session object built with an eye for
   	extensibility

=cut

sub construct {
	my ($self, %args) = @_;

	$args{UID} = $args{Server}->getCookie($args{UseCookie})->value()
		if exists $args{Server} && defined $args{Server} &&
		   exists $args{UseCookie} && defined $args{UseCookie};

	%args = $self->SUPER::construct(%args);

	$self->load();

	return %args;
}

1;
