package Puma::Socket::NTExec;
use ibase Puma::Socket::XML;

use Puma::Util::XML 'xml2hash';

use Data::Dumper;

use strict;

# === This be the API! ======================================================
sub processXML {
	my $self = shift;

	# --- load the config file ---
	my $config = xml2hash(File => $self->{config})->{NTExec};

	# --- get the received xml hash ---
	my $ntexec = $self->{xmlhash}->{NTExec};

	my $cmd;
	# --- found a service control command ---
	if (exists $ntexec->{service}) {
		my $svc = $ntexec->{service};
		SWITCH: {
			# --- start a service ---
			exists $svc->{start} && do {
				$cmd = "$config->{programs}->{sc} start $svc->{query}\n";
				last;
			};
			# --- stop a service ---
			exists $svc->{stop} && do {
				$cmd = "$config->{programs}->{sc} stop $svc->{query}\n";
				last;
			};
			# --- query the status of a service ---
			exists $svc->{query} && do {
				$cmd = "$config->{programs}->{sc} query $svc->{query}\n";
				last;
			};
		};
	}

	my $result;
	$result = qx[ $cmd ];

	# --- run the command and dump the output to the client socket ---
	print {$self->{Client}} $result;
}

1;
