#!/usr/bin/perl -w

# === change this stuff to suit your environment ============================

use lib '../../..';

# === end of local customizations ===========================================

use Puma::Config;
use Puma::Socket::ST::Listener;
use Puma::Util::XML 'xml2hash';
use Data::Dumper;

use strict;

# --- load the configuration file ---
my $config = Puma::Config->getConfig()->{puma};
my $listeners = $config->{socket}->{listener} || [];

# --- search through the listeners XML to fin the first NTExec ---
my $found;
foreach my $listenxml (@$listeners) {
	next unless ishouldstart($listenxml);
	if ($listenxml->{module} eq "Puma::Socket::NTExec") {
		$found = $listenxml;
		last;
	}
}

# --- instantiate the class and start the listener ---
my $listener = new Puma::Socket::ST::Listener(%$found);
$listener->listener();

exit 1;

# === Local Subroutines =====================================================
# --- message logger ---
#! TODO: rewrite this in as a package in Puma::Util
#!       or use Sys::Syslog
sub logmsg { print "$0 $$: @_ at ", scalar localtime, "\n" }

# --- returns whether a listener should start ---
sub ishouldstart {
	my $listener = shift;

	return 0 unless exists $listener->{start};
	return 0 unless defined $listener->{start};
	return 1 if $listener->{start} =~ /^\s*(?:yes|y|true|t|1)\s*$/;
	return 0;
}
