package Puma::Socket::Server;
use ibase Puma::Core;

use Puma::Util::NCHash;

use strict;

# === Constructor ===========================================================
sub construct {
	my ($self, $args) = (shift, nchash(@_));

	# --- get the rules for extracting valid labels ---
	$self->stripArgs($args, qw(Client config));

	return $self->SUPER::construct(%$args);
}

sub start {
	my $self = shift;
	my $sock = $self->{Client};

	$self->initialize();
	undef while $self->process;
	$self->terminate()
}

# === Internal / Inherited API ==============================================

sub initialize { print {$_[0]->{Client}} "Connected\n"; }
sub terminate  { print {$_[0]->{Client}} "Goodbye\n"; }

=process stub
	This method really only needs to be a simple stub, but I've added some
	extra lines of code for thehellofit and as a simple example of how it can
	be written.
=cut

sub process {
	my $self = shift;
	my $socket = $self->{Client};

	# --- read line from socket, return 0 if undef (socket is closed) ---
	my $instr = <$socket>;
	return 0 unless defined $instr;

	for ($instr) {
		/^bye/i && do {
			print $socket "Bye, dude!\n";
			return 0;
		};
		/^exit/i && do {
			print $socket "Emergency exits are located above the wings.\n";
			return 0;
		};
		/^quit/i && do {
			print $socket "Quit?  I'll NEVER quit!\n";
			sleep 2;
			print $socket " ... or perhaps I will.\n";
			return 0;
		};

		print $socket "Whattchatalkinabout Willis?!\n";
	}

	return 1;
}

1;
