#!/usr/bin/perl -w

use lib '../..';
use Puma::Socket::NTExec;

use strict;

use Puma::Util::XML 'xml2hash';
use Data::Dumper;

my $config = xml2hash(File => '/etc/puma/config.xml');
my $listeners = $config->{puma}->{socket}->{listener};
my $execonf;

foreach my $listener (@$listeners) {
	if ($listener->{module} eq 'Puma::Socket::NTExec') {
		$execonf = xml2hash(File => $listener->{config});
		last;
	}
}

print Data::Dumper->Dump([$execonf], ['execonf']) ."\n"
