#!/usr/bin/perl -w

# === change this stuff to suit your environment ============================

#use lib '/usr/lib/perl5/site_perl'; # path to Puma (if not in Perl path)
#my $etcdir = '/etc/puma';           # location of Puma's config.xml
#my $configfile = 'config.xml';      # name of Puma's config.xml

# === end of local customizations ===========================================

use lib '../..';

use Puma::Config;
use Puma::Socket::Listener;
use Puma::Util::XML 'xml2hash';
use Data::Dumper;

use strict;

# --- load the configuration file ---
#my $config = xml2hash(File => '/etc/puma/config.xml')->{puma};
my $config = Puma::Config->getConfig()->{puma};
my $listeners = $config->{socket}->{listener} || [];

foreach my $listener (@$listeners) {
	next unless ishouldstart($listener);
	new Puma::Socket::Listener(%$listener);
}

#! TODO: spawn correctly? (or whatever)
sleep 1 while 1;

exit 1;

# === Local Subroutines =====================================================
# --- message logger ---
#! TODO: rewrite this in as a package in Puma::Util
#!       or use Sys::Syslog
sub logmsg { print "$0 $$: @_ at ", scalar localtime, "\n" }

# --- returns whether a listener should start ---
sub ishouldstart {
	my $listener = shift;

	return 0 unless exists $listener->{start};
	return 0 unless defined $listener->{start};
	return 1 if $listener->{start} =~ /^\s*(?:yes|y|true|t|1)\s*$/;
	return 0;
}

#! TODO: find the correct way to implement the reaper

=beware the reaper ---
$SIG{CHLD} = \&REAPER;
sub REAPER {
	my $waitpid = wait;
	$SIG{CHLD} = \&REAPER;
	logmsg "reaped $waitpid" . ($? ? " with exit $?" : "");
}
=cut


=for the unperlified

   $0 $PROGRAM_NAME
      Contains the name of the file containing the Perl script being
      executed. On some operating systems assigning to "$0" modifies the
      argument area that the ps(1) program sees.  This is more useful as a
      way of indicating the current program state than it is for hiding the
      program you're running.  (Mnemonic: same as sh and ksh.)

	$$ $PID $PROCESS_ID
      The process number of the Perl running this script.  (Mnemonic: same
      as shells.)

   @_
      Within a subroutine the array @_ contains the parameters passed to
      that subroutine. See the perlsub manpage.

   $? $CHILD_ERROR
      The status returned by the last pipe close, backtick (``) command, or
      system() operator.  Note that this is the status word returned by the
      wait() system call (or else is made up to look like it).  Thus, the
      exit value of the subprocess is actually ($? >> 8), and $? & 127 gives
      which signal, if any, the process died from, and $? & 128 reports
      whether there was a core dump.  (Mnemonic: similar to sh and ksh.)

      Additionally, if the h_errno variable is supported in C, its value is
      returned via $? if any of the gethost*() functions fail.

      Note that if you have installed a signal handler for SIGCHLD, the
      value of $? will usually be wrong outside that handler.

      Inside an END subroutine $? contains the value that is going to be
      given to exit().  You can modify $? in an END subroutine to change the
      exit status of the script.

      Under VMS, the pragma use vmsish 'status' makes $? reflect the actual
      VMS exit status, instead of the default emulation of POSIX status.

      Also see the section on Error Indicators in the perlvar manpage.

=cut

__END__

	<socket>
		<!-- port # use phone translations 5PXML=57965 -->
		<listener module="Puma::Socket::XML" port="5PXML" start="yes" />
	</socket>


	start = yes/no y/n 1/0 true/false t/f
