#!/usr/bin/perl -w 

package Puma::Util::EMail;
use ibase Exporter;

@EXPORT_OK = qw(sendmail);

use strict;

sub sendmail {
	my %args = @_;

	$args{To}      ||= 'iellenberger@nextrx.com';
	$args{From}    ||= 'build@nextrx.com';
	$args{Subject} ||= '';
	$args{Body}    ||= '';

   # --- send e-mail ---
   open(MAIL, "|/usr/sbin/sendmail -t");
   print MAIL "From: $args{From}\n";
   print MAIL "To: $args{To}\n";
   print MAIL "Subject: $args{Subject}\n\n";
   print MAIL $args{Body};
   close MAIL;

   return;
}


1;

__END__




# This line is not presently used.  It is intended as a reference for the
# PSP::Application object when it is created.
use vars qw($DefaultApplication); $DefaultApplication = 'EMail';

sub process {
   my $self = shift;

   # --- get required elements ---
   # TODO: place error checking here
   my ($from, $to, $subject, $template) = $self->getData(qw(From To Subject Template));

   # --- Instantiate a new parser for the e-mail template ---
   # create new envoronment
   my $env = new Fido::Core::Env;
   # store data in environment where EMail::Field will look for it
   $env->{emaildata} = $self->getData;
   # create a new parser
   my $parser = new PSP::Parser(Env => $env);
   # add the 'email' tag to the parser
   $parser->addKnownTag(TagClass => 'PSPApps::EMail::Field', Prefix => 'email');
   # create a new page
   my $page = new PSP(Env => $env, FileName => $template, Parser => $parser);
   # parse, render and flush the page
   $page->parse; $page->render; $page->flush;
   # grab the e-mail body from the buffer
   my $body = $page->buffer;
   # destroy the environment to eliminate circular links
   $env->destroy;

   # --- send e-mail ---
   open(MAIL, "|/usr/sbin/sendmail -t");
   print MAIL "From: $from\n";
   print MAIL "To: $to\n";
   print MAIL "Subject: $subject\n\n";
   print MAIL $body;
   close MAIL;
   return 1;
}

1;


